import { ElMessage } from 'element-plus'
import type { CellSlotProps } from '../type'

export default function useTableCellClick(tableName?: string) {
  const router = useRouter()
  const route = useRoute()
  const cellClickHandler = (row, column, cell, event) => {
    if (tableName?.includes('FlightWaybill')) {
      switch (column.property) {
        case 'C0':
          router.push({
            path: `${route.path.split('/').slice(0, -1).join('/')}/waybill`,
            query: {
              waybillNO: row.C0,
            },
          })
          break
        default:
          break
      }
    }
    if (tableName === 'DepartureFlightWaybill') {
      switch (column.property) {
        case 'C1':
          ElMessage.info('开发中')
          break
        default:
          break
      }
    }
    if (tableName === 'InternationalDepartureFlightWaybill') {
      switch (column.property) {
        case 'C2':
          ElMessage.info('开发中')
          break
        default:
          break
      }
    }
    if (tableName?.includes('FlightContainer')) {
      switch (column.property) {
        case 'C0':
          ElMessage.info('开发中')
          break
        default:
          break
      }
    }
    if (tableName?.includes('DepartureWaybillGoods')) {
      switch (column.property) {
        case 'C2':
          router.push({
            path: `${route.path.split('/').slice(0, -1).join('/')}/goods`,
            query: {
              waybillNO: route.query.waybillNO,
              goodsNO: row.C2,
            },
          })
          break
        default:
          break
      }
    }
    if (tableName?.includes('ArrivalWaybillGoods')) {
      switch (column.property) {
        case 'C1':
          router.push({
            path: `${route.path.split('/').slice(0, -1).join('/')}/goods`,
            query: {
              waybillNO: route.query.waybillNO,
              goodsNO: row.C1,
            },
          })
          break
        default:
          break
      }
    }
  }
  const cellClickHandlerV2 = ({ column, rowData }: CellSlotProps) => {
    if (tableName?.includes('Airport')) {
      switch (column.columnName) {
        case 'flightNO':
          router.push({
            path: `${route.path.split('/').slice(0, -1).join('/')}/flight`,
            query: {
              flightNO: rowData.flightNO,
              flightDate: rowData.flightDate,
            },
          })
          break
        default:
          break
      }
    }
  }

  return {
    cellClickHandler,
    cellClickHandlerV2,
  }
}
