import type { Ref, CSSProperties } from 'vue'
import { ElTable } from 'element-plus'
import { CommonTableColumn, MaybeRef } from '~/common'

interface tableColumnGroup {
  title: string
  columns: CommonTableColumn[]
}
type CellSlotProps = {
  column: CommonTableColumn
  columns: CommonTableColumn[]
  columnIndex: number
  depth: number
  style: CSSProperties
  rowData: any
  rowIndex: number
  isScrolling: boolean
  expandIconProps?:
    | {
        rowData: any
        rowIndex: number
        onExpand: (expand: boolean) => void
      }
    | undefined
}
type ExportOptions = {
  table: MaybeRef<InstanceType<typeof ElTable>>
  sheetName?: string
  fileName?: string
  headerRowNumber?: number
}
type ExportHandler = (option: ExportOptions) => void
